if BeardLib.Version >= 4.0 then
	return
end

function PlayerStandard:_start_action_reload_enter(t)
	if self._equipped_unit:base():can_reload() then
		local weapon = self._equipped_unit:base()
		local tweak_data = weapon:weapon_tweak_data()
		managers.player:send_message_now(Message.OnPlayerReload, nil, self._equipped_unit)
		self:_interupt_action_steelsight(t)
		if not self.RUN_AND_RELOAD then
			self:_interupt_action_running(t)
		end
		if self._equipped_unit:base():reload_enter_expire_t() and not tweak_data.animations.reload_shell_by_shell then
			local speed_multiplier = self._equipped_unit:base():reload_speed_multiplier()
			self._ext_camera:play_redirect(Idstring("reload_enter_" .. self._equipped_unit:base().name_id), speed_multiplier)
			self._state_data.reload_enter_expire_t = t + self._equipped_unit:base():reload_enter_expire_t() / speed_multiplier
			self._equipped_unit:base():tweak_data_anim_play("reload_enter", speed_multiplier)
			return
		elseif self._equipped_unit:base():reload_enter_expire_t() and tweak_data.animations.reload_shell_by_shell == true then
			local speed_multiplier = self._equipped_unit:base():reload_speed_multiplier()
			self._ext_camera:play_redirect(Idstring("reload_enter_" .. weapon:weapon_tweak_data().animations.reload_name_id), speed_multiplier)
			self._state_data.reload_enter_expire_t = t + self._equipped_unit:base():reload_enter_expire_t() / speed_multiplier
			self._equipped_unit:base():tweak_data_anim_play("reload_enter", speed_multiplier)
			return
		end
		self:_start_action_reload(t)
	end
end

function PlayerStandard:_start_action_reload(t)
	local weapon = self._equipped_unit:base()
	if weapon and weapon:can_reload() then
		weapon:tweak_data_anim_stop("fire")
		local speed_multiplier = weapon:reload_speed_multiplier()
		local empty_reload = weapon:clip_empty() and 1 or 0
		if weapon._use_shotgun_reload then
			empty_reload = weapon:get_ammo_max_per_clip() - weapon:get_ammo_remaining_in_clip()
		end
		local tweak_data = weapon:weapon_tweak_data()
		local reload_anim = "reload"
		local reload_prefix = weapon:reload_prefix() or ""
		local reload_name_id = tweak_data.animations.reload_name_id or weapon.name_id
		if weapon:clip_empty() and not tweak_data.animations.ignore_fullreload or tweak_data.animations.ignore_nonemptyreload then
			local reload_ids = Idstring(reload_prefix .. "reload_" .. reload_name_id)
			local result = self._ext_camera:play_redirect(reload_ids, speed_multiplier)
			Application:trace("PlayerStandard:_start_action_reload( t ): ", reload_ids)
			self._state_data.reload_expire_t = t + (tweak_data.timers.reload_empty or weapon:reload_expire_t() or 2.6) / speed_multiplier
		else
			reload_anim = "reload_not_empty"
			local reload_ids = Idstring(reload_prefix .. "reload_not_empty_" .. reload_name_id)
			local result = self._ext_camera:play_redirect(reload_ids, speed_multiplier)
			Application:trace("PlayerStandard:_start_action_reload( t ): ", reload_ids)
			self._state_data.reload_expire_t = t + (tweak_data.timers.reload_not_empty or weapon:reload_expire_t() or 2.2) / speed_multiplier
		end
		weapon:start_reload()
		if not weapon:tweak_data_anim_play(reload_anim, speed_multiplier) then
			weapon:tweak_data_anim_play("reload", speed_multiplier)
			Application:trace("PlayerStandard:_start_action_reload( t ): ", reload_anim)
		end
		self._ext_network:send("reload_weapon", empty_reload, speed_multiplier)
	end
end